diff -ur nano-4580//AUTHORS nano-4580-fixed//AUTHORS
--- nano-4580//AUTHORS	2013-06-14 13:19:33.440000218 -0500
+++ nano-4580-fixed//AUTHORS	2013-06-28 21:58:52.188000115 -0500
@@ -4,7 +4,7 @@
 -------------------------------------------------------------------------
 
 Chris Allegretta <chrisa@asty.org>
-	* Original program author, former stable series maintainer.
+	* Original program author, stable series maintainer.
 
 David Lawrence Ramsey <pooka109@gmail.com>
 	* Former stable series maintainer.  Multiple buffer support,
diff -ur nano-4580//ChangeLog nano-4580-fixed//ChangeLog
--- nano-4580//ChangeLog	2013-06-14 13:19:33.441000218 -0500
+++ nano-4580-fixed//ChangeLog	2013-06-28 21:58:52.189000114 -0500
@@ -19,14 +19,14 @@
 	* do_cut_text - Fix copying (not cutting) text setting Modified state.  Fixes
 	  issue reported by Benno Schulenberg.
 
-GNU nano 2.3.2 - 2011.03.23
+GNU nano 2.3.2 - 2013.03.23
 2013-03-17 Chris Allegretta <chrisa@asty.org>
 	* Revert r4547 as we should have a new release and the overlap code is not yet
 	  ready for public consumption.
 
 2013-01-20 Chris Allegretta <chrisa@asty.org>
 	* src/text.c (do_histify): Don't allow sigwinch to be received while justifying
-	  as that puts us into a wacky state.  Fixess crash on justify by Joshua Rogers.
+	  as that puts us into a wacky state.  Fixes crash on justify by Joshua Rogers.
 	* configure.ac: Added --with-wordbounds option to let cross compilers force
 	  whether their target system support GNU-style word boundaries or not.  
 	  Originally reported by dave festing.
@@ -38,7 +38,7 @@
 	  actually works before defaulting to it over ncurses!  Shock!
 
 2013-01-13 Chris Allegretta <chrisa@asty.org>
-	* src/utils.c (parse_num): Initalize errno before calling strtol().  Fixes issue
+	* src/utils.c (parse_num): Initialize errno before calling strtol().  Fixes issue
 	  where trying to go to a line number too long will break legitimate goto-lines
 	  for the remainder of the editing session, reported by Joshua Rogers.
 
@@ -49,7 +49,7 @@
 	* configure.ac, src/nano.h: Make search for ncursesw more generalized.
 
 2013-01-02 David Benjamin <davidben@Savannah>
-	* src/search.c (parse_syntax): Fix blatantly and dangerously incorrect  code for 
+	* src/search.c (parse_syntax): Fix blatantly and dangerously incorrect code for 
 	  deleting old syntaxes.
 
 2013-01-02 Mike Frysinger <vapier@gentoo.org>
@@ -68,8 +68,8 @@
 
 2012-02-05 Chris Allegretta <chrisa@asty.org>
 	* src/*: Fix overlapping strings highlighting each other.  new variables in edit_draw 
-	  (slmatcharray, pbegin, paintok), new logic (with repeated setting od values in the 
-	  array but its BFI after all).  FIXME: Need to create a new 'overlap'
+	  (slmatcharray, pbegin, paintok), new logic (with repeated setting of values in the 
+	  array but it's BFI after all).  FIXME: Need to create a new 'overlap'
 	* src/*: Fix a silly issue with the argument to nregcomp, as it's confusing to the caller
 	* src/nano.h: Change the color types to a compiler macro (COLORWIDTH), may not actually 
 	  even be worth doing, but someday who knows how wide a color curses implementation might 
@@ -77,7 +77,7 @@
 
 GNU nano 2.3.1 - 2011.05.10
 2011-05-10 Chris Allegretta <chrisa@asty.org>
-	* text.c (do_enter): Only increment totsize by the auto-indented amount, size the previous line's size was
+	* text.c (do_enter): Only increment totsize by the auto-indented amount, since the previous line's size was
 	  already counted.  Fixes bug reported by Robert Spanjaard.
 
 2011-05-08 Chris Allegretta <chrisa@asty.org>
@@ -105,7 +105,7 @@
 GNU nano 2.3.0 - 2011.02.26
 2011-02-26 Chris Allegretta <chrisa@asty.org>
 	* Change RAW in function_type enum to RAWINPUT, to fix compilation on AIX, 
-	  reported by Richard G  Daniel <skunk@iskunk.org>.
+	  reported by Richard G Daniel <skunk@iskunk.org>.
 
 2011-02-23 Chris Allegretta <chrisa@asty.org>
 	* Fix some more severe warnings from 'g++ -pedantic', from patch originally 
@@ -126,7 +126,7 @@
 	  check_poshistory(), update_poshistory(), and reworking of histfilename().  New FAQ entry
 	  4.15 discussing the change and offering an interoperability workaround.
 	* files.c (load_history): Set last_search to the last search value we loaded from history,
-	  so do_research will succeed without needing to manually load the last seach in.  Fixes
+	  so do_research will succeed without needing to manually load the last search in.  Fixes
 	  bug reported by Matthieu Lejeune.
 
 2011-02-12 Chris Allegretta <chrisa@asty.org>
@@ -178,7 +178,7 @@
 2010-04-14 Chris Allegretta <chrisa@asty.org>
 	* text.c (do_alt_speller): Skip invoking the alt speller if the file size 
 	  is 0 bytes.  Fixes Savannah bug 29393 reported by Mike Frysinger.
-	* files.c (wirte_file): Don't set current_stat when tmp == TRUE, check
+	* files.c (write_file): Don't set current_stat when tmp == TRUE, check
 	  whether current_stat is set when trying to use it, and don't do the
 	  modification check if the filename changed, since we have no way
 	  of knowing about it in that case.  Fixes Savannah bug 29392, reported
@@ -207,7 +207,6 @@
 	  file when its owner doesn't match the edited file. Based on security 
 	  analysis on nano by Dan Rosenberg. [CVE-2010-1160]
 
-
 2010-03-21 Chris Allegretta <chrisa@asty.org>
 	* nano.c (page_stdin et al): Don't attempt to reset/reopen the terminal
 	  settings when reading stdin if it was aborted with SIGINT.  May fix Savannah
@@ -224,20 +223,20 @@
 2010-03-07 Chris Allegretta <chrisa@asty.org>
 	* configure.ac, nano.c (handle_sigwinch): Create check for whether LINES and
 	  COLS can safely be redefined.  Fixes compilation issues with cygwin, and likely
-	  with newer versions of ncurses, fixes Savannah bug 28984 repoted by Andy Koppe
+	  with newer versions of ncurses, fixes Savannah bug 28984 reported by Andy Koppe
 	  and Eric Oliver via mailing list.
 	* winio.c (get_mouseinput) - fix stray semicolon in code, also reported in
 	  bug 28984.
 
 GNU nano 2.2.3 - 2010.02.11
 2010-01-28 Chris Allegretta <chrisa@asty.org>
-	* move.c (do_page_up, do_page_down): Fix for smooth mode not preserving cusor 
+	* move.c (do_page_up, do_page_down): Fix for smooth mode not preserving cursor 
 	  position.  Part one of fix for Savannah bug 21178 by Mike Frysinger.
 
 GNU nano 2.2.2 - 2010.01.17
 2010-01-17 Chris Allegretta <chrisa@asty.org>
 	* nano.c (main), prompt.c (do_statusbar_input): Handle problems with an unmapped 
-	  function due to key rebinding, fixes crashes on FreeBSD repoted by Eitan 
+	  function due to key rebinding, fixes crashes on FreeBSD reported by Eitan 
 	  Adler <eitanadlerlist@gmail.com>.
 
 2010-01-14 Chris Allegretta <chrisa@asty.org>
@@ -329,7 +328,7 @@
 2009-12-01 Chris Allegretta <chrisa@asty.org>
 	* global.c (shortcut_init) - Remove redundant entries for ^Y/^V reported by
 	  Christian Weisgerber.
-	* doc/man/nanorc.5 - Fix typo in Meta documentation, reported by gibboris@gmail.com.
+	* doc/man/nanorc.5 - Fix typo in Meta documentation, reported by <gibboris@gmail.com>.
 
 2009-12-01 David Lawrence Ramsey <pooka109@gmail.com>
 	* global.c (shortcut_init) - Add support for ^P and ^N in the help menu.
@@ -338,9 +337,8 @@
 
 GNU nano 2.2.0 - 2009.11.30
 2009-11-29 Chris Allegretta <chrisa@asty.org>
-	* prompt.c (get_prompt_string) - Universally handle help key when is 
-disabled.  Fixes Savannah
-	  bug 28117 by David Lawrence Ramsey <pooka109@gmail.com>.
+	* prompt.c (get_prompt_string) - Universally handle help key when it is 
+	  disabled.  Fixes Savannah bug 28117 by David Lawrence Ramsey <pooka109@gmail.com>.
 	* chars.c, files.c: Add junk vars to silence the compiler.  Sigh.
 
 2009-11-29 David Lawrence Ramsey <pooka109@gmail.com>
@@ -355,11 +353,11 @@
 	  first in an effort to not corrupt the screen, which contradicts Pico but is consistent
 	  with almost all other text editors.  Fixes Savannah bug 28110/Debian bug 460510
 	  reported by Tim Connors <reportbug@rather.puzzling.org>.
-	* doc/dyntax/makefile.nanorc - Sample Makefile highlighting based on wiki.linuxhelp.net version.
+	* doc/syntax/makefile.nanorc - Sample Makefile highlighting based on wiki.linuxhelp.net version.
 
 2009-11-26 Chris Allegretta <chrisa@asty.org>
 	* winio.c (edit_scroll): Adjust for long lines when scrolling.
-	* rcfile.c (parse_rcfile), initialize size argument to getline(), fixes crash on FreeBSD 
+	* rcfile.c (parse_rcfile): initialize size argument to getline(), fixes crash on FreeBSD 
 	  reported by Eitan Adler <eitanadlerlist@gmail.com>.
 
 2009-11-26 Jordi Mallach <jordi@gnu.org>
@@ -388,7 +386,7 @@
 	  Fixes Savannah bug 24957 by Mike Frysinger.
 
 2009-11-19 Chris Allegretta <chrisa@asty.org>
-	* nano.c (die_save_file) Try nd match the permissions of the file we were
+	* nano.c (die_save_file) Try and match the permissions of the file we were
 	  editing but only make a minimal effort to do so. Fixes Savannah bug 27273
 	  reported by Mike Frysinger.
 
@@ -416,7 +414,7 @@
 2009-11-11 Chris Allegretta <chrisa@asty.org>
 	* winio.c: Large tweaking of cursor and text display based on COLS not COLS - 1, 
 	  due to finally understanding that display_string wasn't being called properly
-	  when softwrap was enabled.  Fixes Savnnah bug 27603, Return key doesn't scroll 
+	  when softwrap was enabled.  Fixes Savannah bug 27603, Return key doesn't scroll 
 	  viewport reported by Hannes Schueller.
 	* - Fix size_t formatting issues with -pedantic
 
@@ -491,7 +489,7 @@
 
 2009-07-11 Chris Allegretta <chrisa@asty.org>
 	* nano-regress: Small tweaks
-	* Change undo code to off unless unabled via a command line option (-u/--undo).  Until this code
+	* Change undo code to off unless enabled via a command line option (-u/--undo).  Until this code
 	  stabilizes this is the only responsible way to treat it.
 
 2009-03-08 Chris Allegretta <chrisa@asty.org>
diff -ur nano-4580//NEWS nano-4580-fixed//NEWS
--- nano-4580//NEWS	2013-06-14 13:19:33.455000218 -0500
+++ nano-4580-fixed//NEWS	2013-06-28 22:11:57.064000072 -0500
@@ -1,68 +1,77 @@
 2013.03.22 - GNU nano 2.3.2 "Annoy your coworkers for fun and profit" is
-                released.  This release introduces vim-style file locking
+		released.  This release introduces vim-style file locking
 		(though not backup/restore), useful when using nano
 		in a multi-editor environment.  Feedback is welcome if
 		you run into any issues with this new code.  Other new
-		features include additional support for word boundary 
+		features include additional support for word boundary
 		checking when cross compiling, fixes for trying to go to
 		an invalid line number, and the usual documentation
-                tweaks.  
+		tweaks.
 
-2011.05.10 - GNU nano 2.3.1 "I'm in space" is released.  This 
+2011.05.10 - GNU nano 2.3.1 "I'm in space" is released.  This
 		release includes some fixes for the new libmagic code, as
 		well as a fix for improper character counts when using
 		auto-indent.  Also included are new syntax highlighting
-		definitions for RPM spec and lua files.  Thanks for 
+		definitions for RPM spec and lua files.  Thanks for
 		using nano and keep circulating the tapes.
 
 2011.02.26 - GNU nano 2.3.0 "Septic surprise" is released.  This first
-		release in the 2.3 unstable series bring several new 
+		release in the 2.3 unstable series bring several new
 		features.  First, libmagic support for syntax highlighting
-		has been added on top of the existing file extension 
-		and header support already available.  Secondly, cursor 
-		position can be saved between editing sessions with 
-		the -P or --poslog command line flags, or via "set poslog" 
-		in your .nanorc.  Also included are some fixes for 
-		compilation with g++, and better handling of issues 
-		writing the backup file, which should reduce the need 
-		for the 'set allow_insecure_backup" nanorc option.  
+		has been added on top of the existing file extension
+		and header support already available.  Secondly, cursor
+		position can be saved between editing sessions with
+		the -P or --poslog command line flags, or via "set poslog"
+		in your .nanorc.  Also included are some fixes for
+		compilation with g++, and better handling of issues
+		writing the backup file, which should reduce the need
+		for the 'set allow_insecure_backup" nanorc option.
 		Don't stop, get it get it, don't stop, get it get it.
 
+2010.11.22 - GNU nano 2.2.6 "Pimp my BBS" wants you to go to
+		www.desertbus.org and donate a few bucks for the great
+		Child's Play Charity!  This is just a small release to
+		update a bug where restricted mode was not particularly
+		restricted since key bindings were introduced.  It also
+		signals the return of win32 builds which now feature
+		nanorc support; please see the FAQ for details of how
+		to enable it, this feature is a bit of a kludge for now.
+		Remember that when all else fails, USE SPACE JUMP.
+
 2010.08.05 - GNU nano 2.2.5 "Inactivity timeout" is now available.
-		This release includes slightly less restrictive checkng
-		when writing files in strange environments (e.g. 
+		This release includes slightly less restrictive checking
+		when writing files in strange environments (e.g.
 		when being used out of crontab).  For very strange situations
 		(such as where you cannot change the permissions on the
-		file you're writing, there is a new rc file option 
+		file you're writing, there is a new rc file option
 		"allow_insecure_backup" to be even more permissive and
 		allowing the write to proceed.  Also included are
 		some syntax highlighting updated, and that is about it.
 		Keep fighting the good fight children.
 
 2010.04.15 - GNU nano 2.2.4 is nobody's fool.  First and foremost,
-		this relase includes some security fixes due to
+		this release includes some security fixes due to
 		an assessment of nano's vulnerability to symlink attacks
 		on open files.  The CVEs fixed with this release are
 		CVE-2010-1160 and CVE-2010-1161.  Also included are fixes
 		for various crash modes when using the spell checker
 		on new files in multibuffer mode (surely you've used
 		that combination recently? No?) as well as a fixing
-		the 'file was modified' message when saving to a 
+		the 'file was modified' message when saving to a
 		new filename (since how would nano know?).  And
-		the list would not be complete without our 
+		the list would not be complete without our
 		third-times-the-charm fixes to page up/down due to
-		the soft wrapping code.  The lone new feature 
-		included is a new syntax higlighting definition for 
+		the soft wrapping code.  The lone new feature
+		included is a new syntax highlighting definition for
 		cmake-related files.  Please do consider upgrading to
 		this release if still using the 2.0 series since
 		fixes for that version are still forthcoming.
 
-
 2010.02.11 - GNU nano 2.2.3 "fumbling toward stability" is released.
-		This release contains a fix for only one bug, but a 
-		rather irritating one: when paging up/down with smooth 
-		scrolling, the cursor position was not being preserved 
-		due to a bug in 2.2.2. With such a targeted fix 
+		This release contains a fix for only one bug, but a
+		rather irritating one: when paging up/down with smooth
+		scrolling, the cursor position was not being preserved
+		due to a bug in 2.2.2. With such a targeted fix
 		like this what could POSSIBLY go WRONG?  Hahaha.
 		Enjoy and if you find new bugs, as always please
 		use Savannah's bug tracker.
@@ -82,19 +91,18 @@
 
 2009.12.12 - GNU nano 2.2.1 "DLR strikes back" is open for business.
 		This release fixes many bugs, including: missing
-		keybindings for page up/down and GotoDir in the browser, 
-		^P/^N in the help menu, and restoration of M-W as the 
+		keybindings for page up/down and GotoDir in the browser,
+		^P/^N in the help menu, and restoration of M-W as the
 		default re-search binding.  Other fixes include several
-		issues with compiler warnings and configure options, and 
-		documentation updates, including the nano texinfo manual, 
+		issues with compiler warnings and configure options, and
+		documentation updates, including the nano texinfo manual,
 		nano and nanorc man pages, and UPGRADE file, and some
 		missing syntax highliting entries for the saple nanorc.
 		And no release would be complete without the latest round
-		of 'final' soft wrapping fixes!  Finally, nano will no 
-		longer print a warning when attempting to insert the 
-		contents of a read-only file into an existing buffer.  
+		of 'final' soft wrapping fixes!  Finally, nano will no
+		longer print a warning when attempting to insert the
+		contents of a read-only file into an existing buffer.
 		Enjoy and Happy Hanukkah.
-		
 
 2009.11.30 - GNU nano 2.2.0 "Doc Brown" is released!  The culmination
 		of almost two years of development and hot on the heels
@@ -103,54 +111,54 @@
 		include several fixes for tiny mode (involving both
 		the help keys and replace menu text), more 'final'
 		fixes for soft wrapping, and several typo and documentation
-		updates including nanorc tweaks and a new syntax 
+		updates including nanorc tweaks and a new syntax
 		highlighting file for makefiles. Also included is a long
 		standing fix for random crashing when using nanorc on
 		FreeBSD, and nano will no longer clear the screen on
 		suspend to maintain compatibility with other *nix editors.
 		For those who haven't been playing along at home, please
 		see the official web page for the summary of new
-		features since 2.0.  Special thanks to all who have 
-		submitted bug reports recently in support of our new 
-		stable release, and apologies for all those bugs we 
+		features since 2.0.  Special thanks to all who have
+		submitted bug reports recently in support of our new
+		stable release, and apologies for all those bugs we
 		didn't yet find :-) Peace to all.
 
 2009.11.21 - GNU nano 2.1.99pre2 is available for a special pre-Black
 		Friday discount.  Included are some (hopefully
 		final) fixes for issues with last page display
 		caused by the soft wrapping code, and a fix for
-		a long standing issue with hittig the home key when 
+		a long standing issue with hittig the home key when
 		going through the search history.  On the features
-		front, nano will now attempt to retain the proper 
-		ownership and permissions when trying to create a 
-		.save file due to receiving a signal.  Nano can also 
-		now unbind keys from one or more menus via the 'unbind' 
-		keyword.   Finally, passing --fill or --nowrap on 
-		the command line will now override any related 
-		.nanorc entries.  Speak now or forever hold your bugs!	
+		front, nano will now attempt to retain the proper
+		ownership and permissions when trying to create a
+		.save file due to receiving a signal.  Nano can also
+		now unbind keys from one or more menus via the 'unbind'
+		keyword.   Finally, passing --fill or --nowrap on
+		the command line will now override any related
+		.nanorc entries.  Speak now or forever hold your bugs!
 
 2009.11.15 - GNU nano 2.1.99pre1 "take a bow" is out there, man, it's
-		out there all right.  This release contains mainly 
-		bugfixes, underscoring that we are preparing for the 
-		next stable series release.  Included are many fixes 
-		for the new soft wrapping code, compiler warning tweaks, 
-		and the modification time warning no longer triggers 
-		when saving a file as a new name.  Also include are 
-		some fixes for various nanorc options, and there are 
-		surely more bugs to find before we call the code base 
+		out there all right.  This release contains mainly
+		bugfixes, underscoring that we are preparing for the
+		next stable series release.  Included are many fixes
+		for the new soft wrapping code, compiler warning tweaks,
+		and the modification time warning no longer triggers
+		when saving a file as a new name.  Also include are
+		some fixes for various nanorc options, and there are
+		surely more bugs to find before we call the code base
 		stable, so please keep those reports coming!
 
 2009.09.14 - GNU nano 2.1.11 is on very thin ice, very thin ice, very thin
 		ice.  This release includes two new features: first, nano
 		will check whether the current file is writable when it
 		is opened, and warn if it is not on the status bar. Secondly,
-		a new soft-wrapping (AKA full line display) option is 
+		a new soft-wrapping (AKA full line display) option is
 		available, which will attempt to fully display the contents
 		of lines longer than the width of the screen without the
 		usual truncation and a '$' symbol at the end of the line.
-		It can be enabled via Meta-$ inside the editor, via the 
-		-$ or --softwrap command line flags, or "set softwrap" 
-		in your .nanorc).  As always please report any bugs to the 
+		It can be enabled via Meta-$ inside the editor, via the
+		-$ or --softwrap command line flags, or "set softwrap"
+		in your .nanorc).  As always please report any bugs to the
 		nano Savannah project page
 		(http://savannah.gnu.org/bugs/?func=additem&group=nano)
 		Remember: data loss happens, back up your files.
@@ -160,76 +168,75 @@
 		compiler combos, various compiler warnings, and some crash
 		fixes in the undo code.  On the topic of the latter item,
 		the undo code is now marked as experimental since it can
-		cause severe stability and memory issues, and thus now 
-		requires a flag (-u, --undo) in order to enable it.  
-		Please feel free to continue to test the undo code and 
+		cause severe stability and memory issues, and thus now
+		requires a flag (-u, --undo) in order to enable it.
+		Please feel free to continue to test the undo code and
 		thanks again for using nano for your text editing needs.
 		Go team Nano!
 
 2009.02.16 - GNU nano 2.1.9 wonders what all that glass is doing on the
-		floor!  This release is primarily meant as a less buggy 
-		version of 2.1.8, particularly for issues with the new 
-		sped-up syntax highlighting code.  Other fixes include 
-		configure-time detection of groff HTML support before 
-		attempting to generate the HTML version of man pages, 
-		and using ~ or ~username syntax in .nanorc should now 
-		work again.  Also, nano will now only ask for one 
-		acknowledgement of errors it encounters when parsing 
-		nanorc files, and a new flag -q (--quiet) will silence 
-		these messages altogether.  Give it a go, and happy 
+		floor!  This release is primarily meant as a less buggy
+		version of 2.1.8, particularly for issues with the new
+		sped-up syntax highlighting code.  Other fixes include
+		configure-time detection of groff HTML support before
+		attempting to generate the HTML version of man pages,
+		and using ~ or ~username syntax in .nanorc should now
+		work again.  Also, nano will now only ask for one
+		acknowledgement of errors it encounters when parsing
+		nanorc files, and a new flag -q (--quiet) will silence
+		these messages altogether.  Give it a go, and happy
 		birthday lenny!
 
 2009.02.07 - GNU nano 2.1.8 "unsafe at any speed" is released.  This
-		release include some long overdue performance 
+		release include some long overdue performance
 		improvements in syntax color highlighting, the ability
 		to abort running searches (useful mainly when
 		editing very large files) and the ability to use nano
 		like a pager for viewing standard input (i.e. "nano -").
-		Additionally, there are gentoo syntax highlighting 
-		updates and fixes for issues with reading files 
-		in a directory with strange parent directory permissions. 
-		The key bindings code was also substantially changed 
-		in order to be more ISO-C compatible.  Be sure to use 
-		the Savannah page not only for bug reports but for any 
-		features you would like to see before the next stable 
+		Additionally, there are gentoo syntax highlighting
+		updates and fixes for issues with reading files
+		in a directory with strange parent directory permissions.
+		The key bindings code was also substantially changed
+		in order to be more ISO-C compatible.  Be sure to use
+		the Savannah page not only for bug reports but for any
+		features you would like to see before the next stable
 		series is released.  Have fun with it!
-		
 
 2008.11.10 - GNU nano 2.1.7 "Effingham" is ready to make good on those
 		campaign promises of lower bug rates and 50% more pie.
 		This release includes a new check for external
-		modifications when saving a file, some code and 
-		documentation cleanups, and more bug fixes for 
+		modifications when saving a file, some code and
+		documentation cleanups, and more bug fixes for
 		the new undo code (but we continue to welcome your bug
-		reports via the Savananh bug page at 
+		reports via the Savananh bug page at
 		http://savannah.gnu.org/bugs/?func=additem&group=nano.
 		Come get some.
 
 2008.10.03 - GNU nano 2.1.6 was for new features before it was against
-		them.  This release includes more undo capability, 
+		them.  This release includes more undo capability,
 		several new syntax highlighting configurations including
 		Objective C, OCaml, and Fortran, and a new capability
 		to activate highlighting based on the 1st line of the
-		file being edited.  Also, the new default configure 
+		file being edited.  Also, the new default configure
 		options now include color syntax highlighting, .nanorc
 		support, multibuffer and extras.  These items can still
 		be disabled and are not enabled with --enable-tiny.  Bug
-		fixes include better signal handling under Cygwin, and 
+		fixes include better signal handling under Cygwin, and
 		that's about it.  Again please remember to
-		submit bug reports via Savannah at 
+		submit bug reports via Savannah at
 		http://savannah.gnu.org/bugs/?func=additem&group=nano
-		as undo functions certainly need more testing.  
+		as undo functions certainly need more testing.
 		Bon appetit.
 
 2008.08.30 - GNU nano 2.1.5 is ready to lead on day one.  This release
 		contains a better fix for incorrectly reported successful
 		writes on full filesystems, more helpful messages when
-		an internal error occurs in the undo code, and fixes for 
-		various combinations of configure-time options and 
-		compiler flags.  Also included is new support for 
+		an internal error occurs in the undo code, and fixes for
+		various combinations of configure-time options and
+		compiler flags.  Also included is new support for
 		changing the rc file name at configure time, and
-		using GNU-style regexes for word-boundaries on systems 
-		which do not support them natively, as well as the ever 
+		using GNU-style regexes for word-boundaries on systems
+		which do not support them natively, as well as the ever
 		popular translation updates.  Rock the tarball.
 
 2008.08.09 - GNU nano 2.1.4 "I told you so!" is released.  This release
@@ -242,42 +249,42 @@
 		are likely to run out of space; see Savannah bug 24000.
 		Have fun with it!
 
-2008.08.04 - GNY nano 2.1.3 "least stable version ever" is released.  This
+2008.08.04 - GNU nano 2.1.3 "least stable version ever" is released.  This
 		release includes new (and experimental) undo and redo
-		functionality for most text operations.  The default 
+		functionality for most text operations.  The default
 		key bindings are Meta-U for undo and Meta-E for redo, but
 		these can be remapped using the new 2.1 keybinding code.
-		Also included are some fixes for configuring using wide 
-		curses, crashing when invoking the help menu with 
+		Also included are some fixes for configuring using wide
+		curses, crashing when invoking the help menu with
 		certain locales, and not saving the search history when
 		compiled with configure options.
 
 2008.04.24 - GNU nano 2.1.2 "New York City" is released.  This release
-		contains fixes for binding bad keys, some 
-		configure-specific compilation failures, and more issues 
-		with the new input back end and in particular the status 
-		bar.  Also fixed are some long standing issues with 
+		contains fixes for binding bad keys, some
+		configure-specific compilation failures, and more issues
+		with the new input back end and in particular the status
+		bar.  Also fixed are some long standing issues with
 		compiling on AIX, and a segfault when making the terminal
 		window too small.  Rest in Peace Tim and George!
 
 2008.04.01 - GNU nano 2.1.1 wont get fooled again.  This release contains
 		fixes for the new user-rebindable keys (in particular
 		bracket match which was mis-bound), and various
-		problems with translations and configure-related 
+		problems with translations and configure-related
 		compilation problems are now fixed as well.
-		It also contains new syntax highlighting 
-		definitions for TCL, PHP, Gentoo and Debian-related 
-		files, and some documentation updates as well. 
-		Please continue to send reports with the key 
+		It also contains new syntax highlighting
+		definitions for TCL, PHP, Gentoo and Debian-related
+		files, and some documentation updates as well.
+		Please continue to send reports with the key
 		binding code to the Savannah page
 		(https://savannah.gnu.org/bugs/?group=nano).
-		
+
 2008.03.18 - GNU nano 2.1.0 "under old mismanagement" is released.
 		This first release in the 2.1 development series
 		introduces rebinadble keys for most actions inside
                 the editor.  Please see the nanorc(5) page for
-		more information on configuring key bindings.  Please 
-		also report all keybinding bugs (crashes, missing 
+		more information on configuring key bindings.  Please
+		also report all keybinding bugs (crashes, missing
 		menu functions) using the Savannah bug tracker URL,
 		https://savannah.gnu.org/bugs/?group=nano and
 		thanks for sticking with us!
@@ -916,7 +923,7 @@
 		also features mutt's case insensitive string compare
 		function for more speed and less memory usage.  Two new
 		translations are included, Ukrainian and Russian.
-	
+
 05/12/2001 - GNU nano 1.0.2 is the "just the bugfixes ma'am" release.
 		The most noticeable fixes are for display errors using
 		page up/down with the marker code, and view mode (-v)
diff -ur nano-4580//doc/faq.html nano-4580-fixed//doc/faq.html
--- nano-4580//doc/faq.html	2013-06-14 13:19:30.096000218 -0500
+++ nano-4580-fixed//doc/faq.html	2013-06-28 22:01:55.761000159 -0500
@@ -47,7 +47,7 @@
   <a href="#4.12">4.12. I've compiled nano with color support, but I don't see any color when I run it!</a><br>
   <a href="#4.13">4.13. How do I select text for or paste text from the clipboard in an X terminal when I'm running nano in one and nano's mouse support is turned on?</a><br>
   <a href="#4.14">4.14. When I paste text into a document, each line gets indented further than the last. Why does nano do this, and how can I avoid it?</a><br>
-  <a href="#4.15">4.15. On startup I get a message that says "Detected a legacy nano history file".  Now other nano versionc can't find my search history!</a></p></blockquote>
+  <a href="#4.15">4.15. On startup I get a message that says "Detected a legacy nano history file".  Now other nano versions can't find my search history!</a></p></blockquote>
 <h2><a href="#5">5. Internationalization</a></h2>
 <blockquote><p><a href="#5.1">5.1. There's no translation for my language!</a><br>
   <a href="#5.2">5.2. I don't like the translation for &lt;x&gt; in my language. How can I fix it?</a><br>
@@ -223,8 +223,8 @@
 <blockquote><p>Try holding down the Shift key and selecting or pasting the text as you normally would.</p></blockquote>
 <h2><a name="4.14"></a>4.14. When I paste text into a document, each line gets indented further than the last. Why does nano do this, and how can I avoid it?</h2>
 <blockquote><p>You have the autoindent feature turned on. Hit Meta-I to turn it off, paste your text, and then hit Meta-I again to turn it back on.</p></blockquote>
-<h2><a name="4.15"></a>4.15. On startup I get a message that says "Detected a legacy nano history file".  Now other nano versionc can't find my search history!</h2>
-<blockquote><p>In nano 2.3.0, cursor position history was introduced, and both files now reside under a .nano directory in your home.  Nano was trying to move this file into the new location so it could continue to use it.  This means that if you try and use an earlier version of nano, it will be unable to see your previous search history.  To fix this, run the following commands:<br>
+<h2><a name="4.15"></a>4.15. On startup I get a message that says "Detected a legacy nano history file".  Now other nano versions can't find my search history!</h2>
+<blockquote><p>In nano 2.3.0, cursor position history was introduced, and both files now reside under a .nano directory in your home.  nano was trying to move this file into the new location so it could continue to use it.  This means that if you try and use an earlier version of nano, it will be unable to see your previous search history.  To fix this, run the following commands:<br>
 mv ~/.nano/search_history ~/.nano_history<br>
 ln -sf ~/.nano_history ~/.nano/search_history<br>
 </p></blockquote>